PUBLIC oTlbRunProg

oTlbRunProg = CREATEOBJECT("runprogtlb")
IF VARTYPE(oTlbRunProg) = 'O' .AND. !ISNULL(oTlbRunProg)
   oTlbRunProg.Caption = "..."
   oTlbRunProg.Show
ENDIF

**************************************************
*-- Class:        runprogtlb
*-- ParentClass:  toolbar
*-- BaseClass:    toolbar
*-- Time Stamp:   01/20/07 09:20:10 PM
*
DEFINE CLASS runprogtlb AS toolbar

Caption = ""
Height = 28
Left = 0
Top = 0
Width = 121
Name = "runprogtlb"

ADD OBJECT command1 AS commandbutton WITH ;
        Top = 3, ;
        Left = 5, ;
        Height = 22, ;
        Width = 23, ;
        Caption = "", ;
        StatusBarText = "   Winword   ", ;
        ToolTipText = " Winword", ;
        Name = "Command1"

ADD OBJECT command2 AS commandbutton WITH ;
        Top = 3, ;
        Left = 27, ;
        Height = 22, ;
        Width = 23, ;
        Caption = "", ;
        StatusBarText = "  Excel    ", ;
        ToolTipText = " Excel", ;
        Name = "Command2"

ADD OBJECT command3 AS commandbutton WITH ;
        Top = 3, ;
        Left = 49, ;
        Height = 22, ;
        Width = 23, ;
        Caption = "", ;
        StatusBarText = "     ", ;
        ToolTipText = " ", ;
        Name = "Command3"

ADD OBJECT command4 AS commandbutton WITH ;
        Top = 3, ;
        Left = 71, ;
        Height = 22, ;
        Width = 23, ;
        Caption = "", ;
        StatusBarText = "/        ", ;
        ToolTipText = "  /", ;
        Name = "Command4"

ADD OBJECT command5 AS commandbutton WITH ;
        Top = 3, ;
        Left = 93, ;
        Height = 22, ;
        Width = 23, ;
        Caption = "", ;
        Name = "Command5"

PROCEDURE _runprog
PARAMETERS lcProgName
PRIVATE oShl
IF VARTYPE(lcProgName) = 'C' .AND. !ISNULL(lcProgName)
   TRY
   oShl=CreateObject("WScript.Shell")
   oShl.Run(lcProgName,1,.F.)
   CATCH
   MESSAGEBOX("  : "+lcProgName,4096,2000)
   ENDTRY
ELSE
   MESSAGEBOX("    ",4096,2000)
ENDIF
ENDPROC

PROCEDURE officereg
PARAMETERS lcOfficeType
PRIVATE poReg1, poReg2, poShell, pcExtension
IF VARTYPE(lcOfficeType) = "C" .AND. !ISNULL(lcOfficeType)
   lcOfficeType = UPPER(ALLTRIM(lcOfficeType))
   DO CASE
   CASE lcOfficeType == "WORD"
      pcExtension = "doc"
   CASE lcOfficeType == "EXCEL"
      pcExtension = "xls"
   CASE lcOfficeType == "ACCESS"
      pcExtension = "mdb"
   CASE lcOfficeType == "POWERPOINT"
      pcExtension = "ppt"
   CASE lcOfficeType == "PUBLISHER"
      pcExtension = "pub"
   OTHERWISE
      RETURN -2 && ,   lcOfficeType     
   ENDCASE
   TRY
   poShell = CreateObject("WScript.Shell")
   poReg1  = poShell.RegRead("HKEY_CLASSES_ROOT\\.&pcExtension\\")
   poReg2  = poShell.RegRead("HKEY_CLASSES_ROOT\\.&pcExtension\\Content Type")
   CATCH
   EXIT
   ENDTRY
   IF (VARTYPE(poReg1) = "C" .AND. !ISNULL(poReg1)) .AND.;
           (VARTYPE(poReg2) = "C" .AND. !ISNULL(poReg2))
      RETURN IIF((lcOfficeType $ UPPER(poReg1)) .AND.;
              (lcOfficeType $ UPPER(poReg2)),1,0)
   ELSE
      RETURN -3 &&  OLE        
		                  &&       '
   ENDIF
ELSE
   RETURN -1 && ,   lcOfficeType  
ENDIF
ENDPROC

PROCEDURE Init
PRIVATE iCount, oShl, cSysDir
iCount=0

IF This.Officereg("WORD")>0
   iCount = iCount + 1
   This.command1.Visible= .T.
   This.Command1.Enabled= .T.
   This.command1.Picture="_word.jpg"
ELSE
   This.command1.Visible= .F.
   This.Command1.Enabled= .F.
   This.command1.Picture=""
ENDIF

IF This.Officereg("EXCEL")>0
   iCount = iCount + 1
   This.command2.Visible= .T.
   This.Command2.Enabled= .T.
   This.command2.Picture="_excel.jpg"
ELSE
   This.command2.Visible= .F.
   This.Command2.Enabled= .F.
   This.command2.Picture=""
ENDIF

TRY
oShl=CreateObject("WScript.Shell")
cSysDir = oShl.ExpandEnvironmentStrings("%WinDir%")
CATCH
cSysDir = ""
ENDTRY
IF FILE(cSysDir+"\system32\calc.exe")
   iCount = iCount + 1
   This.command3.Visible= .T.
   This.Command3.Enabled= .T.
   This.command3.Picture="_calc.jpg"
ELSE
   This.command3.Visible= .F.
   This.Command3.Enabled= .F.
   This.command3.Picture=""
ENDIF

IF .T.
   iCount = iCount + 1
   This.command4.Visible= .T.
   This.Command4.Enabled= .T.
   This.command4.Picture="calendar.bmp"
ENDIF

IF .T.
   This.command5.Visible= .F.
   This.Command5.Enabled= .F.
   This.command5.Picture=""
ENDIF

IF iCount>0
   This.Dock(0)
   RETURN .T.
ELSE
   RETURN .F.
ENDIF
ENDPROC

PROCEDURE command1.Click
THIS.Parent._runprog("winword.exe")
ENDPROC

PROCEDURE command2.Click
THIS.Parent._runprog("excel.exe")
ENDPROC

PROCEDURE command3.Click
THIS.Parent._runprog("calc.exe")
ENDPROC

PROCEDURE command4.Click
ACTIVATE WINDOW calendar
ENDPROC

ENDDEFINE
*
*-- EndDefine: runprogtlb
**************************************************
